<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="700"
        >
          <json-view :data="$data" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <v-card>
      <!-- <v-card-title>
        <v-spacer></v-spacer>
         <v-text-field
          v-model.trim="search"
          class="float-right pt-0 mt-0"
          clearable
          label="Buscar..."
          type="text"
          single-line
          hide-details
        >
          <template v-slot:append>
            <v-tooltip bottom>
              <template v-slot:activator="{ on }">
                <v-icon v-on="on">mdi-card-search-outline</v-icon>
              </template>
              Buscar
            </v-tooltip>
          </template>
        </v-text-field>
      </v-card-title>-->
      <v-data-table
        hide-default-header
        fixed-header
        disable-sort
        group-by="eje"
        :items-per-page="100"
        hide-default-footer
        :headers="headersNegocios"
        :items="rowsDisciplinas"
        :search="search"
        locale="es-MX"
        height="445"
        class="protocolos-disciplinas"
      >
        <template v-slot:no-data>
          No se encuentran disciplinas
        </template>
        <template v-slot:header="{ props: { headers } }">
          <thead>
            <tr class="header">
              <th
                :class="[
                  { 'width-no': indexHeader === 0 },
                  { 'width-disciplina': indexHeader === 1 },
                  { 'text-center': indexHeader > 1 },
                  { 'text-negocios': indexHeader > 1 },
                  { 'width-negocios': indexHeader > 1 }
                ]"
                v-for="(header, indexHeader) in headers"
                :key="indexHeader"
              >
                <template v-if="indexHeader > 1 && header.item">
                  <v-avatar class="ma-0" size="80" tile>
                    <v-img
                      :contain="true"
                      :aspect-ratio="1"
                      position="center"
                      :src="header.item.src_logo"
                      :lazy-src="header.item.src_logo"
                      class="white--text align-end"
                      height="80"
                    >
                      <template v-slot:placeholder>
                        <v-row
                          class="fill-height ma-0"
                          align="center"
                          justify="center"
                        >
                          <v-progress-circular
                            indeterminate
                            color="grey lighten-5"
                          ></v-progress-circular>
                        </v-row>
                      </template>
                    </v-img>
                  </v-avatar>
                </template>
                <br />
                <strong>{{ header.text }}</strong>
                <div>
                  <template v-if="indexHeader === 0"
                    ><strong>No.</strong></template
                  >
                  <template v-if="indexHeader === 1">
                    <strong>Nombre de la disciplina</strong>
                  </template>
                  <template v-if="indexHeader > 1"
                    ><strong>Vincular medición</strong></template
                  >
                </div>
              </th>
            </tr>
          </thead>
        </template>
        <template
          v-for="(itemHeader, indexItemHeader) in headersNegocios"
          v-slot:[itemHeaderDynamicSlot(itemHeader.value)]="{ item }"
        >
          <template
            v-if="
              itemHeader.value === 'no' ||
                itemHeader.value === 'disciplina_name'
            "
          >
            {{ item[itemHeader.value] }}
          </template>
          <template v-else>
            <div :key="indexItemHeader + '-' + item.no">
              <v-autocomplete
                v-model="item[itemHeader.value].currentValue"
                @input="
                  updateProtocolosDisciplina(item[itemHeader.value], $event)
                "
                class="mt-0 pt-1"
                no-data-text="No hay elementos para vincular"
                placeholder="Vincular medición"
                :items="
                  getProtocolosByNegocio(
                    item[itemHeader.value].positions.indexNegocioModelo,
                    item[itemHeader.value].positions.indexPlain
                  )
                "
                dense
                chips
                width="100px"
                small-chips
                multiple
                clearable
                item-text="descripcion"
                item-value="id_protocolo"
                background-color="white"
              >
                <template
                  v-slot:selection="{ attrs, item, index, parent, selected }"
                >
                  <v-chip
                    label
                    small
                    v-bind="attrs"
                    :input-value="selected"
                    v-if="index < 1"
                    :color="!selected ? 'primary' : ''"
                  >
                    <span>{{ item.descripcion }}</span>
                  </v-chip>
                  <span v-if="index === 1" class="grey--text caption">
                    ({{ parent.value.length - 1 }} mas )
                  </span>
                </template>
                <template
                  v-if="
                    $v.negociosModelo.$each[
                      item[itemHeader.value].positions.indexNegocioModelo
                    ].ejes_modelo.$each[
                      item[itemHeader.value].positions.indexEjeModelo
                    ].disciplinas_eje_negocio.$each[
                      item[itemHeader.value].positions.indexDisciplinaEje
                    ].protocolos.$error
                  "
                  v-slot:append-outer
                >
                  <v-popover placement="bottom-end" offset="16">
                    <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                    <template slot="popover">
                      <div
                        @click="
                          $v.negociosModelo.$each[
                            item[itemHeader.value].positions.indexNegocioModelo
                          ].ejes_modelo.$each[
                            item[itemHeader.value].positions.indexEjeModelo
                          ].disciplinas_eje_negocio.$each[
                            item[itemHeader.value].positions.indexDisciplinaEje
                          ].protocolos.$reset()
                        "
                        v-close-popover
                      >
                        <span
                          v-if="
                            !$v.negociosModelo.$each[
                              item[itemHeader.value].positions
                                .indexNegocioModelo
                            ].ejes_modelo.$each[
                              item[itemHeader.value].positions.indexEjeModelo
                            ].disciplinas_eje_negocio.$each[
                              item[itemHeader.value].positions
                                .indexDisciplinaEje
                            ].protocolos.required
                          "
                          >¡No te olvides de éste campo!</span
                        >
                        <span
                          v-if="
                            !$v.negociosModelo.$each[
                              item[itemHeader.value].positions
                                .indexNegocioModelo
                            ].ejes_modelo.$each[
                              item[itemHeader.value].positions.indexEjeModelo
                            ].disciplinas_eje_negocio.$each[
                              item[itemHeader.value].positions
                                .indexDisciplinaEje
                            ].protocolos.noRequired
                          "
                          >¡No es necesario este dato si cuenta con protocolos
                          en GEK!</span
                        >
                      </div>
                    </template>
                  </v-popover>
                </template>
              </v-autocomplete>
            </div>
          </template>
        </template>
        <template v-slot:group.header="{ group, groupBy, headers }">
          <th :colspan="headers.length">
            <center>
              {{ serviceCommons.titleCase(group) }}
            </center>
          </th>
        </template>
      </v-data-table>
    </v-card>
  </div>
</template>
<style scoped>
.width-negocios {
  width: 350px;
  min-width: 350px;
}
.width-no {
  width: 100px;
  min-width: 50px;
}
.width-disciplina {
  width: auto;
  min-width: 300px;
}
.header th {
  height: 80px;
  padding: 0px;
}
</style>
<style>
.protocolos-disciplinas.v-data-table div {
  max-height: 445px;
}
.protocolos-disciplinas.v-data-table table {
  background: whitesmoke;
}
.protocolos-disciplinas.v-data-table
  tbody
  tr:hover:not(.v-data-table__expanded__content):not(.v-row-group__header) {
  background: none;
}
.protocolos-disciplinas.v-data-table
  tbody
  tr:not(:last-child)
  td:not(.v-data-table__mobile-row):not(.v-row-group__header) {
  border-bottom: 1px dashed #9e9e9e;
}
.protocolos-disciplinas.v-data-table tbody tr td {
  height: 90px !important;
  vertical-align: middle !important;
}
</style>
<script>
import store from "@/store";
import { required, requiredIf } from "vuelidate/lib/validators";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const urlServicesPlataformaFranquicia =
  store.state.urlServicesPlataformaFranquicia;
const defaultHeaders = [
  {
    text: "",
    value: "no",
    item: null,
    align: "left",
    index: -3
  },
  {
    text: "",
    value: "disciplina_name",
    item: null,
    align: "left",
    index: -2
  },
  {
    text: "Eje",
    value: "eje",
    item: null,
    align: "left",
    index: -1
  }
];
function merge(a, b, prop) {
  var reduced = a.filter(function(aitem) {
    return !b.find(function(bitem) {
      return aitem[prop] === bitem[prop];
    });
  });
  return reduced.concat(b);
}
export default {
  name: "Component-GestionDisciplinasNegocioModelo",
  props: ["data"],
  data() {
    return {
      access_token: serviceLocalStorage.getAccessToken(),
      search: ""
    };
  },
  validations: {
    negociosModelo: {
      $each: {
        ejes_modelo: {
          $each: {
            disciplinas_eje_negocio: {
              $each: {
                protocolos: {
                  required: function(item, parent) {
                    /*let finalItems = item.filter(
                      itemProtocoloDisciplina =>
                        !itemProtocoloDisciplina.deleted
                    );
                    if (parent.data.isGek) {
                      return true;
                    }
                    if (this.negociosModelo.length > 0) {
                      let positions = parent.data.positions;
                      let protocolosGek = this.negociosModelo[
                        this.negociosModelo.length - 1
                      ].ejes_modelo[positions.indexEjeModelo]
                        .disciplinas_eje_negocio[positions.indexDisciplinaEje]
                        .protocolos;
                      if (protocolosGek.length > 0) {
                        return true;
                      }
                    }
                    return finalItems.length > 0;*/
                    return true;
                  },
                  noRequired: function(item, parent) {
                    /*if (parent.data.isGek) {
                      return true;
                    }
                    let finalItems = item.filter(
                      itemProtocoloDisciplina =>
                        !itemProtocoloDisciplina.deleted
                    );
                    if (this.negociosModelo.length > 0) {
                      let positions = parent.data.positions;
                      let protocolosGek = this.negociosModelo[
                        this.negociosModelo.length - 1
                      ].ejes_modelo[positions.indexEjeModelo]
                        .disciplinas_eje_negocio[positions.indexDisciplinaEje]
                        .protocolos;
                      if (protocolosGek.length > 0) {
                        if (finalItems.length == 0) {
                          return true;
                        }
                        return false;
                      }
                      return true;
                    }*/
                    return true;
                  }
                }
              }
            }
          }
        }
      }
    }
  },
  computed: {
    negociosModelo() {
      if (!this.data.modelo.negocios_modelo) {
        return [];
      } else {
        let negociosModelo = JSON.parse(
          JSON.stringify(this.data.modelo.negocios_modelo)
        );
        negociosModelo.forEach((itemNegocioModelo, indexItemNegocioModelo) => {
          let negocio = this.getNegocioFromMetadata(
            itemNegocioModelo.id_negocio
          );
          let isGek = negocio.descripcion.toLowerCase() === "gek";
          if (itemNegocioModelo.ejes_modelo) {
            itemNegocioModelo.ejes_modelo.forEach(
              (itemEjeModelo, indexItemEjeModelo) => {
                if (itemEjeModelo.disciplinas_eje_negocio) {
                  itemEjeModelo.disciplinas_eje_negocio.forEach(
                    (
                      itemDisciplinaEjeNegocio,
                      indexItemDisciplinaEjeNegocio
                    ) => {
                      itemDisciplinaEjeNegocio.data = {
                        positions: {
                          indexNegocio: indexItemNegocioModelo,
                          indexEjeModelo: indexItemEjeModelo,
                          indexDisciplinaEje: indexItemDisciplinaEjeNegocio
                        },
                        isGek: isGek
                      };
                    }
                  );
                }
              }
            );
          }
        });
        return negociosModelo;
      }
    },
    metadata() {
      if (!this.data.metadata) {
        return {};
      }
      return this.data.metadata;
    },
    modelo() {
      if (!this.data.modelo) {
        return {};
      }
      return this.data.modelo;
    },
    serviceCommons() {
      return serviceCommons;
    },
    headersNegocios() {
      let headers = JSON.parse(JSON.stringify(defaultHeaders));
      if (this.modelo.negocios_modelo) {
        this.modelo.negocios_modelo.forEach(
          (itemNegocioModelo, indexItemNegocioModelo) => {
            let negocio = this.getNegocioFromMetadata(
              itemNegocioModelo.id_negocio
            );
            let header = {
              text: negocio.descripcion,
              value: "header_" + indexItemNegocioModelo,
              item: negocio,
              align: "center",
              index: indexItemNegocioModelo
            };
            headers.push(header);
          }
        );
      }
      return headers;
    },
    rowsDisciplinas() {
      let rows = [];
      if (this.modelo.ejes_modelo) {
        let no = 0;
        this.modelo.ejes_modelo.forEach((itemEjeModelo, indexItemEjeModelo) => {
          if (!itemEjeModelo.deleted) {
            let eje = this.getEjeFromMetadata(itemEjeModelo.id_eje);
            if (itemEjeModelo.disciplinas_eje) {
              itemEjeModelo.disciplinas_eje.forEach(
                (itemDisciplinaEje, indexItemDisciplinaEje) => {
                  no++;
                  if (!itemDisciplinaEje.deleted) {
                    let disciplina = this.getDisciplinaFromMetadata(
                      itemDisciplinaEje.id_disciplina
                    );
                    let row = {
                      no: no,
                      disciplina_name: disciplina.descripcion,
                      eje: eje.descripcion
                    };
                    if (this.modelo.negocios_modelo) {
                      this.modelo.negocios_modelo.forEach(
                        (itemNegocioModelo, indexItemNegocioModelo) => {
                          let positions = {
                            indexPlain: no - 1,
                            indexNegocioModelo: indexItemNegocioModelo,
                            indexEjeModelo: indexItemEjeModelo,
                            indexDisciplinaEje: indexItemDisciplinaEje
                          };
                          const disciplinasEjeNegocio = this.data.modelo
                            .negocios_modelo[positions.indexNegocioModelo]
                            .ejes_modelo[positions.indexEjeModelo]
                            .disciplinas_eje_negocio;
                          const disciplinaProtocolo =
                            disciplinasEjeNegocio[positions.indexDisciplinaEje];
                          if (disciplinaProtocolo) {
                            const currentValue = disciplinaProtocolo.protocolos;
                            const currentProtocolos = [];
                            currentValue.forEach((itemProtocoloDisciplina) => {
                              if (!itemProtocoloDisciplina.deleted) {
                                currentProtocolos.push(
                                  itemProtocoloDisciplina.id_protocolo
                                );
                              }
                            });
                            let originalItem = {
                              positions,
                              currentValue: currentProtocolos
                            };
                            row[
                              "header_" + indexItemNegocioModelo
                            ] = originalItem;
                          }
                        }
                      );
                    }
                    rows.push(row);
                  }
                }
              );
            }
          }
        });
      }
      return rows;
    }
  },
  methods: {
    getProtocolosByNegocio(indexNegocio, indexDisciplinaEje) {
      let protocolosSelected = [];
      let negociosModelo = this.modelo.negocios_modelo;
      let disciplinasEjesNegocio = [];
      if (negociosModelo) {
        let negocio = negociosModelo[indexNegocio];
        if (negocio) {
          let ejesModeloNegocio = negocio.ejes_modelo;
          if (ejesModeloNegocio) {
            ejesModeloNegocio.forEach(
              (itemEjeModeloNegocio, indexItemEjeModeloNegocio) => {
                let disciplinasEjeNegocio =
                  itemEjeModeloNegocio.disciplinas_eje_negocio;
                if (disciplinasEjeNegocio) {
                  disciplinasEjeNegocio.forEach(
                    (itemDisciplinaEje, indexItemDisciplinaEje) => {
                      disciplinasEjesNegocio.push(itemDisciplinaEje);
                    }
                  );
                }
              }
            );
          }
        }
        disciplinasEjesNegocio.forEach(
          (itemDisciplinaEjeNegocio, indexItemDisciplinaEjeNegocio) => {
            if (indexDisciplinaEje !== indexItemDisciplinaEjeNegocio) {
              let protocolosDisciplina = itemDisciplinaEjeNegocio.protocolos;
              protocolosDisciplina.forEach((itemProtocoloDisciplina) => {
                if (!itemProtocoloDisciplina.deleted) {
                  protocolosSelected.push(itemProtocoloDisciplina.id_protocolo);
                }
              });
            }
          }
        );
      }
      let procolos = JSON.parse(JSON.stringify(this.metadata.protocolos));
      let procolosFiltered = procolos.filter((itemProtocolo) => {
        return !protocolosSelected.includes(itemProtocolo.id_protocolo);
      });
      return procolosFiltered;
    },
    itemHeaderDynamicSlot(key) {
      return `item.${key}`;
    },
    getDisciplinaFromMetadata(id_disciplina) {
      if (this.metadata.disciplinas) {
        let disciplina_filtered = this.metadata.disciplinas.filter(
          (itemDisciplina) => itemDisciplina.id_disciplina === id_disciplina
        )[0];
        if (disciplina_filtered) {
          return disciplina_filtered;
        }
        return {};
      }
      return {};
    },
    getEjeFromMetadata(id_eje) {
      if (this.metadata.ejes) {
        let eje_filtered = this.metadata.ejes.filter(
          (itemEje) => itemEje.id_eje === id_eje
        )[0];
        if (eje_filtered) {
          return eje_filtered;
        }
        return {};
      }
      return {};
    },
    getNegocioFromMetadata(id_negocio) {
      if (this.metadata.negocios) {
        let negocio_filtered = this.metadata.negocios.filter((itemNegocio) => {
          const src_logo =
            urlServicesPlataformaFranquicia +
            "/file/secure/read/" +
            this.serviceCommons.stringToBase64(itemNegocio.path_logo) +
            "?access_token=" +
            this.access_token;
          itemNegocio.src_logo = src_logo;
          return itemNegocio.id_negocio === id_negocio;
        })[0];
        if (negocio_filtered) {
          return negocio_filtered;
        }
        return {};
      }
      return {};
    },
    updateProtocolosDisciplina(item, value) {
      const positions = item.positions;
      if (this.modelo.negocios_modelo) {
        const negocioModelo = this.modelo.negocios_modelo[
          positions.indexNegocioModelo
        ];
        if (negocioModelo) {
          if (negocioModelo.ejes_modelo) {
            const ejeNegocio =
              negocioModelo.ejes_modelo[positions.indexEjeModelo];
            if (ejeNegocio) {
              const disciplinaEjeNegocio =
                ejeNegocio.disciplinas_eje_negocio[
                  positions.indexDisciplinaEje
                ];
              if (disciplinaEjeNegocio) {
                let protocolos = this.modelo.negocios_modelo[
                  positions.indexNegocioModelo
                ].ejes_modelo[positions.indexEjeModelo].disciplinas_eje_negocio[
                  positions.indexDisciplinaEje
                ].protocolos;
                let protocolosTemp = [];
                let currentValues = value.forEach((itemProtocolo) => {
                  protocolosTemp.push({
                    id_protocolo: itemProtocolo,
                    id_protocolo_disciplina: null
                  });
                });
                let procolosMerged = merge(
                  protocolosTemp,
                  protocolos,
                  "id_protocolo"
                );
                procolosMerged = procolosMerged.filter(
                  (itemProtocoloDisciplina) => {
                    if (!value.includes(itemProtocoloDisciplina.id_protocolo)) {
                      itemProtocoloDisciplina.deleted = true;
                    } else {
                      delete itemProtocoloDisciplina.deleted;
                    }
                    let filtered =
                      itemProtocoloDisciplina.deleted &&
                      !itemProtocoloDisciplina.id_protocolo_disciplina;
                    if (!filtered) {
                      return itemProtocoloDisciplina;
                    }
                  }
                );
                this.modelo.negocios_modelo[
                  positions.indexNegocioModelo
                ].ejes_modelo[positions.indexEjeModelo].disciplinas_eje_negocio[
                  positions.indexDisciplinaEje
                ].protocolos = procolosMerged;
              }
            }
          }
        }
      }
    }
  }
};
</script>
